com.ihr.xbrl.om.exLinks

## Class CalculationLinkbase

- java.lang.Object
- - com.ihr.xbrl.om.XMLFragment
  - - com.ihr.xbrl.om.exLinks.XLinkElement
    - - com.ihr.xbrl.om.exLinks.XBRLExtendedLink
      - - com.ihr.xbrl.om.exLinks.CalculationLinkbase

- All Implemented Interfaces:
    HasAdditionalEqualityForReassignation, XBRLAllowsDocumentation, XBRLRelationshipPoint, Thinable, XBRLDTSDocument, XBRLValidation, XMLHasParent, java.lang.Cloneable, javax.xml.namespace.NamespaceContext

      public class CalculationLinkbase
      extends XBRLExtendedLink

  The Class CalculationLinkbase.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface com.ihr.xbrl.om.XBRLValidation

      `XBRLValidation.Direction`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static javax.xml.namespace.QName` | `lbType` link:calculationLink.
    `static javax.xml.namespace.QName` | `standard_arc` link:calculationArc.
    `static java.lang.String` | `standard_role_ref` Used on taxonomies to refer to a calculation linkbase.
    `static java.lang.String` | `summation_item_arcrole_URI` http://www.xbrl.org/2003/arcrole/summation-item
    `static javax.xml.namespace.QName` | `weight` The Constant weight.

    - ### Fields inherited from class com.ihr.xbrl.om.exLinks.XBRLExtendedLink

      `standard_role_URI`

    - ### Fields inherited from class com.ihr.xbrl.om.exLinks.XLinkElement

      `actuate, ACTUATE, ARC, arcrole, ARCROLE, ETITLE, EXTENDED, from, FROM, href, HREF, label, LABEL, LOCATOR, RESOURCE, role, ROLE, show, SHOW, SIMPLE, title, TITLE, to, TO, type, TYPE`

    - ### Fields inherited from class com.ihr.xbrl.om.XMLFragment

      `CONCEPT_LABEL, CONCEPT_QNAME, EASY_TO_READ, ELEMENT_LABEL, EMPTYRELATIONSHIPSITERATORINSTANCE, EMPTYXMLFRAGMENTITERATORINSTANCE, FACT_CONCEPT_DATATYPE, FACT_CONCEPT_LABEL, FACT_QNAME, HIDE_COMMON_ACCURACY, idQName, NO_POSITION, OrderComparator, OrderComparator2, PERIOD_TYPE, PERIOD_VALUE, SHORT_TEXT, SOURCE_DOCUMENT, XPATH, XPOINTER`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `CalculationLinkbase(XBRLDocument parent, DTSBase base)` Deprecated. use `CalculationLinkbase(XBRLDocument, XBRLRoleType)` instead
    `CalculationLinkbase(XBRLDocument parent, XBRLRoleType role)` Creates a CalculationLinkbase extended link.
    `CalculationLinkbase(XBRLDocument parent, net.sf.saxon.s9api.XdmNode node)` Instantiates a new calculation linkbase.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.String` | `getExtendedLinkTypeName()` Returns a localized constant string indicating the extended link type
    `java.util.Collection<java.lang.String>` | `getStandardDefinedRolesOnResources()` Returns a collection of role URIs that the XBRL 2.1 standard defines to be used on resources on this extended link
    `java.util.Collection<javax.xml.namespace.QName>` | `getStandardResourceNodeNames()` Returns a collection of resource node names that are allowed to exist on this extended link.
    `javax.xml.namespace.QName` | `getStaticLinkbaseType()` This function MUST be implemented by classes derived from this class.
    `static double` | `getWeight(XBRLRelationship rel)` Obtains the value of the weight attribute on a calculationArc (or derived) relationship.
    `boolean` | `isStandardExtendedLink()` Returns true if the extended link belongs to the XBRL 2.1 specification.

    - ### Methods inherited from class com.ihr.xbrl.om.exLinks.XBRLExtendedLink

      `addDocumentation, addRelationship, addResource, clear, clearCaches, createExtendedLink, createExtendedLink, createExtendedLink, discoverDTS, equals, generateNode, getArcroles, getArcroleType, getArcs, getAttributes, getDocumentation, getDTSBase, getDTSKey, getElements, getFriendlyName, getLinkbaseType, getLocators, getNumberOfResources, getParent, getRelationships, getResources, getRoleType, getValidationReport, hashCode, invalidate, invalidate, isOnValidation, removeDocumentation, removeRelationship, removeResource, setDTSBase, setParent, setRole, setRoleType, validate, wouldBeDuplicateArc`

    - ### Methods inherited from class com.ihr.xbrl.om.exLinks.XLinkElement

      `getActuate, getArcrole, getFromTxt, getHRef, getLabel, getRole, getShow, getStaticLabel, getSType, getTitle, getToTxt, isRequiredAttribute, isValidAttribute, setActuate, setArcrole, setFrom, setHRef, setLabel, setShow, setSType, setTitle, setTo`

    - ### Methods inherited from class com.ihr.xbrl.om.XMLFragment

      `addAttribute, addChild, addFromRelationship, addNamespace, addNamespace, addToRelationship, addXMLChild, changeBase, checkBase, clone, clone, delAttribute, delAttribute, equalXdmValues, evaluateBoolean, evaluateList, evaluateNode, evaluateNumber, evaluateString, generateId, generateNodeNamespacesAndAttributes, generateNodeValue, generatePrefix, getAllAttributes, getAttribute, getAttributeBooleanValue, getAttributeQNameValue, getAttributes, getAttributeStringValue, getAttributeValue, getBase, getBase, getBaseURI, getBooleanValue, getChild, getContainer, getContainerDocumentURI, getDeclaredNamespaces, getDocument, getElementsHashCode, getFragment, getFriendlyName, getFromRelationships, getFromRelationships, getFromRelationships, getFromRelationships, getFromRelationships, getGenericLabelText, getId, getLang, getNamespaceURI, getNodeName, getNumberOfAttributes, getNumberOfElements, getNumberOfFromRelationships, getNumberOfToRelationships, getOrGenerateId, getPrefix, getPrefixes, getQNameValue, getRelationshipsBases, getRelationshipsChain, getRelationshipTypes, getStaticContext, getStaticNamespace, getStringValue, getToolTipText, getToRelationships, getToRelationships, getToRelationships, getToRelationships, getToRelationships, getValue, getXPathExecutable, getXPathNamespaceContext, getXPathToNode, getXPathToRoot, getXPointerElementScheme, getXPointerElementScheme, getXPointerShorthandScheme, getXPointerToNode, isDead, isNamespaceDefined, isXdmDocumentAttached, objEquals, objHashCode, qNameToString, removeAttribute, removeChild, removeChild, removeFromRelationship, removeToRelationship, removeXMLChild, resetElements, resetHash, resolve_equal2, resolveHRef, resolveHRef, s_equal2, s_equal2, s_equal2, setAttributes, setBase, setDocument, setDocumentAndReload, setElements, setId, setLang, setNamespaceContext, setNamespaces, setNode, setNodeName, setParent, setRegenerateNodeIfnotFound, setValue, setValue, setVariablesDefined, size, thin, toString, valueEquals, xEqual`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.ihr.xbrl.om.exLinks.XBRLAllowsDocumentation

      `getContainer`

    - ### Methods inherited from interface com.ihr.xbrl.om.XMLHasParent

      `addXMLChild, getBase, removeXMLChild, setParent`

- - ### Field Detail

    - #### summation_item_arcrole_URI

          public static final java.lang.String summation_item_arcrole_URI

      http://www.xbrl.org/2003/arcrole/summation-item
      See Also:
        Constant Field Values

    - #### lbType

          public static final javax.xml.namespace.QName lbType

      link:calculationLink.

    - #### standard_arc

          public static final javax.xml.namespace.QName standard_arc

      link:calculationArc.

    - #### standard_role_ref

          public static final java.lang.String standard_role_ref

      Used on taxonomies to refer to a calculation linkbase.
      See Also:
        Constant Field Values

    - #### weight

          public static final javax.xml.namespace.QName weight

      The Constant weight.

  - ### Constructor Detail

    - #### CalculationLinkbase

          public CalculationLinkbase(XBRLDocument parent,
                             net.sf.saxon.s9api.XdmNode node)

      Instantiates a new calculation linkbase.
      Parameters:
        `parent` - the parent
        `node` - the node

    - #### CalculationLinkbase

          public CalculationLinkbase(XBRLDocument parent,
                             DTSBase base)
                              throws XBRLInconsistentDTSException

      Deprecated. use `CalculationLinkbase(XBRLDocument, XBRLRoleType)` instead
      Instantiates a new calculation linkbase.
      Parameters:
        `parent` - XBRLDocument
        `base` - DTSBase
      Throws:
        `XBRLInconsistentDTSException` - the XBRL inconsistent dts exception

    - #### CalculationLinkbase

          public CalculationLinkbase(XBRLDocument parent,
                             XBRLRoleType role)

      Creates a CalculationLinkbase extended link.
      Parameters:
        `parent` - the parent
        `role` - the role
      Since:
        2.6.5

  - ### Method Detail

    - #### getStaticLinkbaseType

          public javax.xml.namespace.QName getStaticLinkbaseType()

      Description copied from class: `XBRLExtendedLink`
      This function MUST be implemented by classes derived from this class.
      Specified by:
        `getStaticLinkbaseType` in class `XBRLExtendedLink`
      Returns:
        QName indicating the LinkbaseType like xbrli:footnoteLinkbase etc.

    - #### getExtendedLinkTypeName

          public java.lang.String getExtendedLinkTypeName()

      Description copied from class: `XBRLExtendedLink`
      Returns a localized constant string indicating the extended link type
      Specified by:
        `getExtendedLinkTypeName` in class `XBRLExtendedLink`
      Returns:
        String

    - #### getWeight

          public static double getWeight(XBRLRelationship rel)
                                  throws XBRLValidationException

      Obtains the value of the weight attribute on a calculationArc (or derived) relationship. If the attribute is not defined or the value is not a number a proper error is raised.
      Parameters:
        `rel` - The relationship the weight attribute has to be read
      Returns:
        a double value or an exception is raised
      Throws:
        `XBRLValidationException` - in case an error occurs or the value is not a proper Double value.

    - #### isStandardExtendedLink

          public boolean isStandardExtendedLink()

      Description copied from class: `XBRLExtendedLink`
      Returns true if the extended link belongs to the XBRL 2.1 specification. This means it is a PresentationLinkbase, CalculationLinkbase, DefinitionLinkbase, LabelLinkbase, FootnoteLinkbase or ReferenceLinkbase
      Specified by:
        `isStandardExtendedLink` in class `XBRLExtendedLink`
      Returns:
        a boolean value that is true for XBRL 2.1 extended links only

    - #### getStandardResourceNodeNames

          public java.util.Collection<javax.xml.namespace.QName> getStandardResourceNodeNames()

      Description copied from class: `XBRLExtendedLink`
      Returns a collection of resource node names that are allowed to exist on this extended link.
      Specified by:
        `getStandardResourceNodeNames` in class `XBRLExtendedLink`
      Returns:
        collection of QNames, if no resources are allowed this is an empty collection of QNames

    - #### getStandardDefinedRolesOnResources

          public java.util.Collection<java.lang.String> getStandardDefinedRolesOnResources()

      Description copied from class: `XBRLExtendedLink`
      Returns a collection of role URIs that the XBRL 2.1 standard defines to be used on resources on this extended link
      Specified by:
        `getStandardDefinedRolesOnResources` in class `XBRLExtendedLink`
      Returns:
        collection of strings